package nc.ui.cm.fetchdata.action;

package ..deTemp.1730279270916;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import nc.bs.framework.common.NCLocator;
import nc.itf.mmpac.apply.task.ITaskAMaintainService;
import nc.itf.pubapp.pub.smart.IBillQueryService;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.md.data.access.NCObject;
import nc.ui.cm.fetchdata.view.ListFetchDataMainPnl;
import nc.ui.uif2.AppEventListener;
import nc.ui.uif2.NCAction;
import nc.ui.uif2.ShowStatusBarMsgUtil;
import nc.ui.uif2.model.BillManageModel;
import nc.vo.bd.period2.AccperiodmonthVO;
import nc.vo.cm.fetchdata.entity.PullDataStateVO;
import nc.vo.jcom.xml.XMLUtil;
import nc.vo.mmpac.apply.task.entity.AggTaskAVO;
import nc.vo.mmpac.apply.task.entity.TaskABVO;
import nc.vo.mmpac.apply.task.entity.TaskAHVO;
import nc.vo.org.DeptVO;
import nc.vo.org.OrgVO;
import nc.vo.pub.lang.MultiLangText;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public class ZysbdCopyAction extends NCAction {
  private IUAPQueryBS iq;
  
  private ListFetchDataMainPnl listFetchDataMainPnl;
  
  private BillManageModel model;
  
  public ZysbdCopyAction() {
    setBtnName("数据同步");
    setCode("zysbdCopyAction");
  }
  
  public void doAction(ActionEvent arg0) throws Exception {
    PullDataStateVO[] allVOs = getFetchDataMainAllVO();
    IUAPQueryBS iq = getIq();
    byte b;
    int i;
    PullDataStateVO[] arrayOfPullDataStateVO1;
    for (i = (arrayOfPullDataStateVO1 = allVOs).length, b = 0; b < i; ) {
      PullDataStateVO allVO = arrayOfPullDataStateVO1[b];
      String pk_org = allVO.getPk_org();
      Integer pulldatatype = allVO.getPulldatatype();
      String ccostcenterid = allVO.getCcostcenterid();
      if (pulldatatype.intValue() != 2)
        return; 
      String lyorgSql = " select c.pk_org from pub_sysinit a  left join org_orgs b on a.pk_org=b.pk_org and b.dr=0  left join org_orgs c on a.value=c.code and c.def11<>'~' and c.dr=0  where initcode='sphxy02' and b.pk_org='" + 

        
        pk_org + "' ";
      String lyorgpk = (String)iq.executeQuery(lyorgSql, (ResultSetProcessor)new ColumnProcessor());
      if (lyorgpk == null || "N".equals(lyorgpk))
        ExceptionUtils.wrappBusinessException("没有来源组织"); 
      String isqy2 = " select value from pub_sysinit where initcode='sphxy01' and pk_org='" + pk_org + "' and dr=0";
      String isqyvalue2 = (String)iq.executeQuery(isqy2, (ResultSetProcessor)new ColumnProcessor());
      if (isqyvalue2 == null || "N".equals(isqyvalue2))
        ExceptionUtils.wrappBusinessException("目的组织未启用数据同步"); 
      String cperiod = allVO.getCperiod();
      String periodSql = "select * from bd_accperiodmonth where yearmth='" + cperiod + "' ";
      AccperiodmonthVO accperiodVo = (AccperiodmonthVO)iq.executeQuery(periodSql, (ResultSetProcessor)new BeanProcessor(AccperiodmonthVO.class));
      ArrayList<String> lspk = new ArrayList<String>();
      String cbzxSql = " SELECT b.bdcode FROM xx_bdcontra a \r\nLEFT JOIN xx_bdcontra_b b ON a.pk_contra = b.pk_contra \r\nWHERE a.pk_org = '" + 
        
        pk_org + "' AND b.EXSYSVAL IN (\r\n" + 
        "SELECT trim( a.cccode ) FROM resa_costcenter a \r\n" + 
        "LEFT JOIN resa_ccdepts b ON a.pk_costcenter = b.pk_costcenter \r\n" + 
        "WHERE 1 = 1 AND a.pk_costcenter = '" + ccostcenterid + "') ";
      String cbzxdz = (String)iq.executeQuery(cbzxSql, (ResultSetProcessor)new ColumnProcessor());
      if (cbzxdz == null || "".equals(cbzxdz)) {
        String cbzxNameSql = " SELECT a.name FROM resa_costcenter a \r\nLEFT JOIN resa_ccdepts b ON a.pk_costcenter = b.pk_costcenter \r\nWHERE 1 = 1 AND a.pk_costcenter = '" + 
          
          ccostcenterid + "'";
        String cbzxName = (String)iq.executeQuery(cbzxNameSql, (ResultSetProcessor)new ColumnProcessor());
        ExceptionUtils.wrappBusinessException("成本中心:" + cbzxName + "未配置对照");
      } 
      String bmdzSql = " SELECT pk_dept FROM resa_costcenter a LEFT outer\r\nJOIN resa_ccdepts b ON a.pk_costcenter = b.pk_costcenter \r\nWHERE 1 = 1 AND a.cccode IN ('" + 
        
        cbzxdz + "') ";
      String bmdz = (String)iq.executeQuery(bmdzSql, (ResultSetProcessor)new ColumnProcessor());
      if (bmdz == null || "".equals(bmdz))
        ExceptionUtils.wrappBusinessException("部门:" + cbzxdz + "未配置对照"); 
      String deptsql = "select pk_dept from org_dept where pk_org='" + lyorgpk + "' and code in(select code from org_dept where pk_dept in('" + bmdz + "'))\n";
      String oldPkDept = (String)iq.executeQuery(deptsql, (ResultSetProcessor)new ColumnProcessor());
      if (oldPkDept == null || "".equals(oldPkDept))
        ExceptionUtils.wrappBusinessException("未找到部门"); 
      String sql = " SELECT a.PK_TA FROM mm_ta a \n INNER JOIN mm_ta_b b ON a.pk_ta = b.pk_ta \n WHERE 1=1 AND a.dr = 0 AND b.dr = 0 \n AND a.pk_org = '" + 

        
        lyorgpk + "' and a.cdeptid='" + oldPkDept + "' \n" + 
        " AND b.dtaskdate >= '" + accperiodVo.getBegindate() + "' \n" + 
        " AND b.dtaskdate <= '" + accperiodVo.getEnddate() + "'";
      lspk = (ArrayList<String>)iq.executeQuery(sql, (ResultSetProcessor)new ColumnListProcessor());
      IBillQueryService billQuery = 
        (IBillQueryService)NCLocator.getInstance().lookup(IBillQueryService.class);
      if (lspk == null)
        return; 
      for (int j = 0; j < lspk.size(); j++) {
        AggTaskAVO taskaVo = (AggTaskAVO)billQuery.querySingleBillByPk(AggTaskAVO.class, lspk.get(j));
        if (taskaVo == null)
          ExceptionUtils.wrappBusinessException("未查到同步数据"); 
        TaskABVO[] taskabVos = (TaskABVO[])taskaVo.getChildrenVO();
        TaskAHVO taskhVo = (TaskAHVO)taskaVo.getParent();
        taskhVo.setPk_ta(null);
        taskhVo.setVbillcode(null);
        String sqltask = " select a.* from mm_ta a \n where a.vmocode='" + 
          taskhVo.getVmocode() + "' and a.cmaterialvid='" + taskhVo.getCmaterialvid() + "' and pk_org='" + pk_org + "' and a.dr=0 ";
        TaskAHVO mdtaskVo = (TaskAHVO)iq.executeQuery(sqltask, (ResultSetProcessor)new BeanProcessor(TaskAHVO.class));
        if (mdtaskVo != null)
          return; 
        String sbSql = " select f.pk_dept from xx_bdcontra a left join md_class b on a.bdclass=b.id  \n left join xx_exsystem c on a.exsystem = c.pk_exsystem \n left join org_orgs d on c.exsystemcode=d.code \n left join xx_bdcontra_b e on a.pk_contra=e.pk_contra \n left join org_dept f on e.bdcode=f.code and f.dr=0 and f.pk_org='" + 


          
          pk_org + "' \n" + 
          " left join org_dept g on e.exsysval=g.code and g.dr=0  \n" + 
          " where d.pk_org='" + lyorgpk + "' and b.name='dept' and g.pk_dept='" + oldPkDept + "' \n";
        String pkdept = (String)iq.executeQuery(sbSql, (ResultSetProcessor)new ColumnProcessor());
        if (pkdept == null || "".equals(pkdept))
          ExceptionUtils.wrappBusinessException("未找到对照部门"); 
        String deptSql = "select * from org_dept where dr=0 and enablestate=2 and pk_dept='" + pkdept + "'";
        DeptVO deptVo = (DeptVO)iq.executeQuery(deptSql, (ResultSetProcessor)new BeanProcessor(DeptVO.class));
        if (deptVo == null)
          ExceptionUtils.wrappBusinessException("未找到对照部门"); 
        String orgSql = "select * from org_orgs where dr=0 and enablestate=2 and pk_org='" + pk_org + "'";
        OrgVO orgVo = (OrgVO)iq.executeQuery(orgSql, (ResultSetProcessor)new BeanProcessor(OrgVO.class));
        taskhVo.setCdeptid(deptVo.getPk_dept());
        taskhVo.setCdeptvid(deptVo.getPk_vid());
        taskhVo.setPk_org(orgVo.getPk_org());
        taskhVo.setPk_org_v(orgVo.getPk_vid());
        byte b1;
        int k;
        TaskABVO[] arrayOfTaskABVO1;
        for (k = (arrayOfTaskABVO1 = taskabVos).length, b1 = 0; b1 < k; ) {
          TaskABVO taskabVo = arrayOfTaskABVO1[b1];
          taskabVo.setPk_ta_b(null);
          taskabVo.setPk_ta(null);
          taskabVo.setCbdeptid(deptVo.getPk_dept());
          taskabVo.setCbdeptvid(deptVo.getPk_vid());
          taskabVo.setPk_org(orgVo.getPk_org());
          taskabVo.setPk_org_v(orgVo.getPk_vid());
          b1++;
        } 
        AggTaskAVO[] arrayOfAggTaskAVO = ((ITaskAMaintainService)NCLocator.getInstance().lookup(ITaskAMaintainService.class)).insert(new AggTaskAVO[] { taskaVo });
      } 
      b++;
    } 
    ShowStatusBarMsgUtil.showStatusBarMsg("作业申报单已同步完成", getModel().getContext());
  }
  
  protected IUAPQueryBS getIq() {
    if (this.iq == null)
      this.iq = (IUAPQueryBS)NCLocator.getInstance().lookup(IUAPQueryBS.class); 
    return this.iq;
  }
  
  private PullDataStateVO[] getFetchDataMainAllVO() {
    return (PullDataStateVO[])this.listFetchDataMainPnl.getBillListView()
      .getBillListPanel().getHeadBillModel()
      .getBodySelectedVOs(PullDataStateVO.class.getName());
  }
  
  public ListFetchDataMainPnl getListFetchDataMainPnl() {
    return this.listFetchDataMainPnl;
  }
  
  public void setListFetchDataMainPnl(ListFetchDataMainPnl listFetchDataMainPnl) {
    this.listFetchDataMainPnl = listFetchDataMainPnl;
  }
  
  public BillManageModel getModel() {
    return this.model;
  }
  
  public static String getValue(NCObject ncobj, String path) {
    Object obj = ncobj.getAttributeValue(path);
    if (obj == null)
      return ""; 
    if (obj instanceof MultiLangText)
      return XMLUtil.getXMLString(((MultiLangText)obj).getText()); 
    if (obj instanceof UFDouble)
      return ((UFDouble)obj).setScale(2, 4)
        .toString(); 
    return XMLUtil.getXMLString(obj.toString());
  }
  
  public void setModel(BillManageModel model) {
    this.model = model;
    model.addAppEventListener((AppEventListener)this);
  }
}
